#include"NAG.h"



#if defined(NoNag)

#define NONAGERROR(fct)   FatalError("Call of a NAG function" fct \
                                     " when NAG is unavailable");

extern "C" void FortranCall(s15ddf)(Complex*, Complex*,int*)
  
{ NONAGERROR("s15ddf"); return;
}


extern "C" double  FortranCall(s15aef)(double*,int*)

{ NONAGERROR("s15aef"); return -1;
}


extern "C" double  FortranCall(s13acf)(double*, int*)

{ NONAGERROR("s13acf"); return -1;
}

extern "C" double  FortranCall(s13adf)(double*, int* )

{ NONAGERROR("s13adf"); return -1;
}

extern "C" double  FortranCall(s13aaf)(double*, int* )

{ NONAGERROR("s13aaf"); return -1;
}

extern "C" FortranCall(s17dlf)(int *,double *,Complex *,int *,
                   char *, Complex *,int *,int *)

{ NONAGERROR("s17dlf"); return -1;
}

extern "C" FortranCall(s17def)(double *, Complex *,int *, char    *,
                               Complex *, int *,int     *)

{ NONAGERROR("s17def"); return -1;
}


extern "C" double FortranCall(g05ddf)(double &,double &)

{ NONAGERROR("g05ddf"); return -1;
}

extern "C" FortranCall(f07arf)(int&, int&, Complex *, int&, int *,int&)

{ NONAGERROR("f07arf"); return -1;
}

extern "C" FortranCall(f07awf)(int&, Complex *, int&, int*, Complex *, int&, 
                               int&)
                            
{ NONAGERROR("f07awf"); return -1;
}

extern "C" FortranCall(f04aef) (double  A[], int* IA, double  B[], int*    IB,
                                int*    N, int*    M, double  C[], int*    IC,
                                double  WKSPACE[], double  AA[], int*    IAA, 
                                double  BB[], int*    IBB, int*    IFAIL)
   
{ NONAGERROR("f04aef"); return -1;
}

extern "C" FortranCall(f04atf) (double [], int*, double  B[], int*, double [],
                                double [], int*, double [], double[], int*)    

{ NONAGERROR("f04atf"); return -1;
}

extern "C" FortranCall(f03ahf)(int*, Complex [], int*, double*, double*, int*,
                               double[], int*)

{ NONAGERROR("f03ahf"); return -1;
}

extern "C" FortranCall(f04akf)
                  (int*    N,        //the order of the matrix
                   int*    IR,       //the number of the right-hand sides
                   Complex LUA[],    //details of the LU returned by f03ahk
                   int*    IALU,     //the first dimention of the array LUA
                   double  P[],      //details of the row interchanging size:N
                   Complex B[],      //the right and side of the equation
                                     //exit: the solution X
                   int*    IB        //the first dimention of the array B
)
{ NONAGERROR("f04akf"); return -1;
}

extern "C" FortranCall(f03aaf)
                  (double  LUA[],    //details of the LU returned by f03ahk
                   int*    IALU,     //the first dimention of the array LUA
                   int*    N,        //the order of the matrix
                   double* Det,      //exit: determinant
                   double  WKS1[],   //real array size=N
                   int*    IFAIL     //entry: 0,-1,1
                                     //exit: 0 OK
                                     //      1 A is singular
                                     //      2 overflow
                                     //      3 underflow
)
{ NONAGERROR("f03aaf"); return -1;
}

extern "C" FortranCall(f02ajf)(double*     AR,
                   int*       IAR,
                   double*     AI,
                   int*       IAI,
                   int*         N,
                   double*     RR,
                   double*     RI,
                   int*    INTGER,
                   int*     IFAIL)

{ NONAGERROR("f02ajf"); return -1;
}

extern "C" FortranCall(f02aff)(double*      A,
                   int*        IA,
                   int*         N,
                   double*     RR,
                   double*     RI,
                   int*    INTGER,
                   int*     IFAIL)

{ NONAGERROR("f02aff"); return -1;
}

extern "C" FortranCall(c06fjf)(int    *NDim,
                               int    ND[],
                               int    N[],
                               double *X,
                               double *Y,
                               double *Work,
                               int    *LWork,
                               int    *IFail)
{ NONAGERROR("c06fjf"); return -1;
}

extern "C" FortranCall(c06gcf)(double *Y,
                               int    *N,
                               int    *IFAIL)

{ NONAGERROR("c06gcf"); return -1;
}

extern "C" FortranCall(f02gbf)(char&, int&, Complex *, int&, Complex *,
                               Complex *, int&, double*, Complex *, int&, int&)

{ NONAGERROR("f02gbf"); return -1;
}

extern "C" FortranCall(d01ajf)(
          double (*func)(double*),  //(1)  real Function, supplied by the ueser
          double *A,      	    //(2)  the lower limit
          double *B,      	    //(3)  the upper limit
          double *EPSABS, 	    //(4)  absolute accuracy required
          double *EPSREL, 	    //(5)  relative accuracy required
          double *RESULT, 	    //(6)  Entree: the approximation of the 
                                    //     integral
          double *ABSERR, 	    //(7)  On exit: en estimate of the modulus 
                                    //     of the absolute error
          double *W,      	    //(8)  details of the computation
          int    *LW,     	    //(9)  the dimention fo the array W
          int    *IW,    	    //(10) exit: the actual number of
                                    //     subintervals used
          int    *LIW,   	    //(11) dimention of the array IW
          int    *IFAIL  	    //(12) error flag
                          )
{ NONAGERROR("d01ajf"); return -1;
}


extern "C" FortranCall(d01akf)(
          double (*func)(double*),  //(1)  real Function, supplied by the ueser
          double *A,      	    //(2)  the lower limit
          double *B,      	    //(3)  the upper limit
          double *EPSABS, 	    //(4)  absolute accuracy required
          double *EPSREL, 	    //(5)  relative accuracy required
          double *RESULT, 	    //(6)  Entree: the approximation of the 
                                    //     integral
          double *ABSERR, 	    //(7)  On exit: en estimate of the modulus 
                                    //     of the absolute error
          double *W,      	    //(8)  details of the computation
          int    *LW,     	    //(9)  the dimention fo the array W
          int    *IW,    	    //(10) exit: the actual number of
                                    //     subintervals used
          int    *LIW,   	    //(11) dimention of the array IW
          int    *IFAIL  	    //(12) error flag
                          )
{ NONAGERROR("d01akf"); return -1;
}


extern "C" FortranCall(d01alf)(
          double (*func)(double*),  //(1)  real Function, supplied by the ueser
          double *A,      	    //(2)  the lower limit
          double *B,      	    //(3)  the upper limit
          int    *NPTS,   	    //(4)  the number of user-supplied break- 
                                    //     points within the integration 
                                    //     interval >=0
          double *POINTS, 	    //(5)  the user-specified break-points
          double *EPSABS, 	    //(6)  absolute accuracy required
          double *EPSREL, 	    //(7)  relative accuracy required
          double *RESULT, 	    //(8)  Entree: the approximation of the 
                                    //     integral
          double *ABSERR, 	    //(9)  On exit: en estimate of the modulus 
                                    //     of the absolute error
          double *W,      	    //(10) details of the computation
          int    *LW,     	    //(11) the dimention fo the array W
          int    *IW,    	    //(12) exit: the actual number of
                                    //     subintervals used
          int    *LIW,   	    //(13) dimention of the array IW
          int    *IFAIL  	    //(14) error flag
                          )


{ NONAGERROR("d01alf"); return -1;
}

//D01AMF calculates an approximation to the integral of a function f(x) 
//       over a infinite oder semi-infinite interval [a,b]

extern "C" FortranCall(d01amf)(
          double (*func)(double*),  //(1)  real Function, supplied by the ueser
          double *BOUND,      	    //(2)  the finite limit of the integration 
                                    //     range
          int    *INF,      	    //(3)  kind of integration range
				    //     1 : [BOUND, Inf]
                                    //     -1: [-Inf,BOUND]
				    //     -2: [-Inf, Inf]
          double *EPSABS, 	    //(4)  absolute accuracy required
          double *EPSREL, 	    //(5)  relative accuracy required
          double *RESULT, 	    //(6)  Entree: the approximation of the 
                                    //     integral
          double *ABSERR, 	    //(7)  On exit: en estimate of the modulus 
                                    //     of the absolute error
          double *W,      	    //(8)  details of the computation
          int    *LW,     	    //(9)  the dimention fo the array W
          int    *IW,    	    //(10) exit: the actual number of
                                    //     subintervals used
          int    *LIW,   	    //(11) dimention of the array IW
          int    *IFAIL  	    //(12) error flag
                          )

{ NONAGERROR("d01amf"); return -1;
}

//D01DAF attenpts to evaluate a double integral to e specified absolute accuracy
//       by represented application of the method described by Patterson

extern "C" FortranCall(d01daf)(
          double *YA,                //(1)  the lower limit of the integral, a
          double *YB,                //(2)  the upper limit of the integral, b
          double (*fun1)(double*),   //(3)  PHI1(y) lower limit of the integral
          double (*fun2)(double*),   //(4)  PHI2(y) upper limit of the integral
          double (*func)(double*,double*),  
                                    //(5)  real Function, supplied by the ueser
          double *ABSACC, 	    //(6)  absolute accuracy required
          double *ANS, 		    //(7)  estimate of the integral
 	  int	 *NPTS		    //(8)  On exit: the total number of function
				    //     evalutations
      			  )
{ NONAGERROR("d01daf"); return -1;
}


extern "C" FortranCall(d01eaf)(
          int    *NDIM,		    //(1)  the Number of dimentions
          double A[],		    //(2)  the lower limits
          double B[],		    //(3)  the upper limits
          int    MINCLS,            //(4)  the minimum number of FUNSUM calls to
                                    //     be allowed
          int    MAXCLS,            //(5)  the maximum number of FUNSUM calls to
                                    //     be allowed
          int    NFUN,              //(6)  the number of integrands
          void   (*func)(int*,double[],int*,double[]), 
                                    //(7)  function to be evaluate
          double *EPSABS, 	    //(8)  absolute accuracy required
          double *EPSREL, 	    //(9)  relative accuracy required
          int    *LENWRK,           //(10) dimention of the array WRKSTR
          double *WRKSTR,           //(11) workspace
          double FINEST[],          //(12) 
          double ABSEST[],          //(13)
          int    IFAIL)             //(14)

{ NONAGERROR("d01eaf"); return -1;
}
    			  
#endif
