#if !defined(_NAG_)
#define _NAG_

#include"Object.h"
#include"Error.h"
#include"Complex.h"

extern "C" void    FortranCall(s15ddf)(Complex *w, Complex* z,int* ifail);
extern "C" double  FortranCall(s15aef)(double*  z,int* ifail);
extern "C" double  FortranCall(s13acf)(double*, int* ifail);
extern "C" double  FortranCall(s13adf)(double*, int* ifail );
extern "C" double  FortranCall(s13aaf)(double*, int* ifail );
extern "C" FortranCall(s17dlf)(int *M,double *FMU,Complex *Z,int *N,
                   char *SCALE,
                   Complex *CY,int *NZ,int *IFAIL);
extern "C" FortranCall(s17def)(
                   double  *FNU,  //the order v of the first member of the fct.
                   Complex *Z,    //the argument z of the function
                   int     *N,    //number N of members required
                   char    *SCALE,//"S" scaled, "U" unscaled
                   Complex *CY,   //return the N required function values
                   int     *NZ,   //retrun the number of componant set to zero
                                  //       due to underflow
                   int     *IFAIL);

extern "C" double FortranCall(g05ddf)(double &a,double & b);

extern "C" FortranCall(f07arf)(
             int&     M,      //Factorisation of a m*n matrix
             int&     N,      //
             Complex *A,      //complex array
             int&     LDA,    //first dimension of the array A
             int     *IPIV,   //interger array <=N
             int&     Info);  //0 unless the routine has detected an error


extern "C" FortranCall(f07awf)(
             int&     N,      //the order of the matrix
             Complex *A,      //complex array
             int&     LDA,    //first dimension of the array A
             int     *IPIV,   //interger array <=N
             Complex *Work,   //complex array
             int&     LWork,  //the dimension of the array Work
             int&     Info);  //0 unless the routine has detected an error
                              // Info=i<0 the -ith parameter has a illegal val.
                              // Info  >0 the matrix is singular


extern "C" FortranCall(f04aef)
                  (double  A[],      //nXn matrix
                   int*    IA,       //first dimension of the array A
                   double  B[],      //nxm right hand side
                   int*    IB,       //first dimension of the array B
                   int*    N,        //order of the matrix A
                   int*    M,        //number of the right and sides B
                   double  C[],      //nxm solution matrix X
                   int*    IC,       //first dimesion of the matrix C
                   double  WKSPACE[],//real array size=N
                   double  AA[],     //matrix size IAA*N, return the triangular
                                     //factor LU, exept the unit diagonal
                                     //of U.
                   int*    IAA,      //first dimention of AA (IAA>=N)
                   double  BB[],     //nxm matrix residual R=B-AX
                   int*    IBB,      //first dimension of the array BB
                   int*    IFAIL     //entry: 0,-1,1
                                     //exit: 0 OK
                                     //      1 A is singular
                                     //      2 A is too ill-conditioned
);   

extern "C" FortranCall(f04atf)
                  (double  A[],      //nXn matrix
                   int*    IA,       //first dimension of the array A
                   double  B[],      //nx1 right hand side
                   int*    N,        //order of the matrix A
                   double  C[],      //nx1 solution matrix X
                   double  AA[],     //matrix size IAA*N, return the triangular
                                     //factor LU, exept the unit diagonal
                                     //of U.
                   int*    IAA,      //first dimention of AA (IAA>=N)
                   double  WKS1[],   //real array size=N
                   double  WKS2[],   //real array size=N
                   int*    IFAIL     //entry: 0,-1,1
                                     //exit: 0 OK
                                     //      1 A is singular
                                     //      2 A is too ill-conditioned
);   

extern "C" FortranCall(f03ahf)
                  (int*    N,        //the order of the matrix
                   Complex LUA[],    //on entry: the matix A
                                     //on exit:  details of the LU
                   int*    IALU,     //the first dimention of the array LUA
                   double* DETR,
                   double* DETI,
                   int*    ID,       //determinant: (EDTR+i DETI)*2^ID
                   double  RINT[],   //gives the row of the ith pivot
                   int*    IFAIL     //entry: 0,-1,1
                                     //exit: 0 OK
                                     //      1 A is singular
);

extern "C" FortranCall(f04akf)
                  (int*    N,        //the order of the matrix
                   int*    IR,       //the number of the right-hand sides
                   Complex LUA[],    //details of the LU returned by f03ahk
                   int*    IALU,     //the first dimention of the array LUA
                   double  P[],      //details of the row interchanging size:N
                   Complex B[],      //the right and side of the equation
                                     //exit: the solution X
                   int*    IB        //the first dimention of the array B
);

extern "C" FortranCall(f03aaf)
                  (double  LUA[],    //details of the LU returned by f03ahk
                   int*    IALU,     //the first dimention of the array LUA
                   int*    N,        //the order of the matrix
                   double* Det,      //exit: determinant
                   double  WKS1[],   //real array size=N
                   int*    IFAIL     //entry: 0,-1,1
                                     //exit: 0 OK
                                     //      1 A is singular
                                     //      2 overflow
                                     //      3 underflow
);

extern "C" FortranCall(f02ajf)(double*     AR,
                   int*       IAR,
                   double*     AI,
                   int*       IAI,
                   int*         N,
                   double*     RR,
                   double*     RI,
                   int*    INTGER,
                   int*     IFAIL);

extern "C" FortranCall(f02aff)(double*      A,
                   int*        IA,
                   int*         N,
                   double*     RR,
                   double*     RI,
                   int*    INTGER,
                   int*     IFAIL);

extern "C" FortranCall(c06fjf)(int    *NDim,
                               int    ND[],
                               int    N[],
                               double *X,
                               double *Y,
                               double *Work,
                               int    *LWork,
                               int    *IFail);

extern "C" FortranCall(c06gcf)(double *Y,
                               int    *N,
                               int    *IFAIL);


extern "C" FortranCall(f02gbf)(char&    JOB,
                               int&     N,
                               Complex *A,
                               int&     LDA,
			       Complex *W,
			       Complex *V,
			       int&     LDV,
                               double*  RWORK,
			       Complex *WORK,
			       int&     LWORK,
			       int&     IFAIL);



//D01AJF is a general-purposed integrator which calculates an approximation to 
//       the integral of a function f(x) over a finite interval [a,b]

extern "C" FortranCall(d01ajf)(
          double (*func)(double*),  //(1)  real Function, supplied by the ueser
          double *A,      	    //(2)  the lower limit
          double *B,      	    //(3)  the upper limit
          double *EPSABS, 	    //(4)  absolute accuracy required
          double *EPSREL, 	    //(5)  relative accuracy required
          double *RESULT, 	    //(6)  Entree: the approximation of the 
                                    //     integral
          double *ABSERR, 	    //(7)  On exit: en estimate of the modulus 
                                    //     of the absolute error
          double *W,      	    //(8)  details of the computation
          int    *LW,     	    //(9)  the dimention fo the array W
          int    *IW,    	    //(10) exit: the actual number of
                                    //     subintervals used
          int    *LIW,   	    //(11) dimention of the array IW
          int    *IFAIL  	    //(12) error flag
                          );

/**/
//D01AJF is a adaptive integrator, especially suited to oscillating, 
//       non-singular integrands, which calculates an approximation to 
//       the integral of a function f(x) over a finite interval [a,b]

extern "C" FortranCall(d01akf)(
          double (*func)(double*),  //(1)  real Function, supplied by the ueser
          double *A,      	    //(2)  the lower limit
          double *B,      	    //(3)  the upper limit
          double *EPSABS, 	    //(4)  absolute accuracy required
          double *EPSREL, 	    //(5)  relative accuracy required
          double *RESULT, 	    //(6)  Entree: the approximation of the 
                                    //     integral
          double *ABSERR, 	    //(7)  On exit: en estimate of the modulus 
                                    //     of the absolute error
          double *W,      	    //(8)  details of the computation
          int    *LW,     	    //(9)  the dimention fo the array W
          int    *IW,    	    //(10) exit: the actual number of
                                    //     subintervals used
          int    *LIW,   	    //(11) dimention of the array IW
          int    *IFAIL  	    //(12) error flag
                          );

//D01ALF is a general-purposed integrator which calculates an approximation to 
//       the integral of a function f(x) over a finite interval [a,b], where 
//       the integrand may have local singular behaviours at a finite number of
//       points within the integration interval.

extern "C" FortranCall(d01alf)(
          double (*func)(double*),  //(1)  real Function, supplied by the ueser
          double *A,      	    //(2)  the lower limit
          double *B,      	    //(3)  the upper limit
          int    *NPTS,   	    //(4)  the number of user-supplied break- 
                                    //     points within the integration 
                                    //     interval >=0
          double *POINTS, 	    //(5)  the user-specified break-points
          double *EPSABS, 	    //(6)  absolute accuracy required
          double *EPSREL, 	    //(7)  relative accuracy required
          double *RESULT, 	    //(8)  Entree: the approximation of the 
                                    //     integral
          double *ABSERR, 	    //(9)  On exit: en estimate of the modulus 
                                    //     of the absolute error
          double *W,      	    //(10) details of the computation
          int    *LW,     	    //(11) the dimention fo the array W
          int    *IW,    	    //(12) exit: the actual number of
                                    //     subintervals used
          int    *LIW,   	    //(13) dimention of the array IW
          int    *IFAIL  	    //(14) error flag
                          );

/**/

//D01AMF calculates an approximation to the integral of a function f(x) 
//       over a infinite oder semi-infinite interval [a,b]

extern "C" FortranCall(d01amf)(
          double (*func)(double*),  //(1)  real Function, supplied by the ueser
          double *BOUND,      	    //(2)  the finite limit of the integration 
                                    //     range
          int    *INF,      	    //(3)  kind of integration range
				    //     1 : [BOUND, Inf]
                                    //     -1: [-Inf,BOUND]
				    //     -2: [-Inf, Inf]
          double *EPSABS, 	    //(4)  absolute accuracy required
          double *EPSREL, 	    //(5)  relative accuracy required
          double *RESULT, 	    //(6)  Entree: the approximation of the 
                                    //     integral
          double *ABSERR, 	    //(7)  On exit: en estimate of the modulus 
                                    //     of the absolute error
          double *W,      	    //(8)  details of the computation
          int    *LW,     	    //(9)  the dimention fo the array W
          int    *IW,    	    //(10) exit: the actual number of
                                    //     subintervals used
          int    *LIW,   	    //(11) dimention of the array IW
          int    *IFAIL  	    //(12) error flag
                          );


//D01DAF attenpts to evaluate a double integral to e specified absolute accuracy
//       by represented application of the method described by Patterson

extern "C" FortranCall(d01daf)(
          double *YA,                //(1)  the lower limit of the integral, a
          double *YB,                //(2)  the upper limit of the integral, b
          double (*fun1)(double*),   //(3)  PHI1(y) lower limit of the integral
          double (*fun2)(double*),   //(4)  PHI2(y) upper limit of the integral
          double (*func)(double*,double*),  
                                    //(5)  real Function, supplied by the ueser
          double *ABSACC, 	    //(6)  absolute accuracy required
          double *ANS, 		    //(7)  estimate of the integral
 	  int	 *NPTS		    //(8)  On exit: the total number of function
				    //     evalutations
      			  );

//D01EAF computes approximations to the integrals of a vector of similar
//       functions, eatch defined over the same multi-dimentional 
//       hyper-rectangular region. The routine uese an adaptive subdivision
//       strategy, and also compute absolute error estimates.

extern "C" FortranCall(d01eaf)(
          int    *NDIM,		    //(1)  the Number of dimentions
          double A[],		    //(2)  the lower limits
          double B[],		    //(3)  the upper limits
          int    MINCLS,            //(4)  the minimum number of FUNSUM calls to
                                    //     be allowed
          int    MAXCLS,            //(5)  the maximum number of FUNSUM calls to
                                    //     be allowed
          int    NFUN,              //(6)  the number of integrands
          void   (*func)(int*,double[],int*,double[]), 
                                    //(7)  function to be evaluate
          double *EPSABS, 	    //(8)  absolute accuracy required
          double *EPSREL, 	    //(9)  relative accuracy required
          int    *LENWRK,           //(10) dimention of the array WRKSTR
          double *WRKSTR,           //(11) workspace
          double FINEST[],          //(12) 
          double ABSEST[],          //(13)
          int    IFAIL              //(14)
      			  );
#endif

